Package net.dona.doip.client

## Interface SearchResults<T>

- Type Parameters:
    `T` - either String for searchIds or DigitalObject for full search
  All Superinterfaces:
    `java.lang.AutoCloseable`, `java.lang.Iterable<T>`
  All Known Implementing Classes:
    `DoipSearchResults`

      public interface SearchResults<T>
      extends java.lang.Iterable<T>, java.lang.AutoCloseable

  A representation of search results from `DoipClient` search operations. Provides either ids (an {code Iterable} or `Stream` of String objects) or Digital Objects (an `Iterable` or `Stream` of DigitalObject objects).

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` | Closes the search results, releasing the connection to the server.
    `java.util.Iterator<T>` | `iterator()` | Returns an `Iterator` of the search results (either String or DigitalObject).
    `default java.util.stream.Stream<T>` | `parallelStream()` | Returns a potentially parallel `Stream` of the search results (either String or DigitalObject).
    `int` | `size()` | Returns the full number of results across all pages, or -1 if the number is not available
    `default java.util.Spliterator<T>` | `spliterator()` |
    `default java.util.stream.Stream<T>` | `stream()` | Returns an `Stream` of the search results (either String or DigitalObject).

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

- - ### Method Detail

    - #### size

          int size()

      Returns the full number of results across all pages, or -1 if the number is not available

    - #### iterator

          java.util.Iterator<T> iterator()

      Returns an `Iterator` of the search results (either String or DigitalObject).
      Specified by:
        `iterator` in interface `java.lang.Iterable<T>`

    - #### close

          void close()

      Closes the search results, releasing the connection to the server.
      Specified by:
        `close` in interface `java.lang.AutoCloseable`

    - #### spliterator

          default java.util.Spliterator<T> spliterator()

      Specified by:
        `spliterator` in interface `java.lang.Iterable<T>`

    - #### stream

          default java.util.stream.Stream<T> stream()

      Returns an `Stream` of the search results (either String or DigitalObject).

    - #### parallelStream

          default java.util.stream.Stream<T> parallelStream()

      Returns a potentially parallel `Stream` of the search results (either String or DigitalObject).